# Tests

Note: les dégradation grayscale et phantomcharacter contiennent de l'aléatoire, il n'est donc pas possible (dans l'état actuel du projet) de comparer des images de sorties pixel par pixel, les tests correspondant ont donc été mis en commentaires dans le code (/tests/CMakeLists.txt, /tests/wrapper/python/testDegradationWrapper.py et /tests/wrapper/python/testDegradationWrapper.cpp).

## Principe des tests
Il y a 6 tests associés chacuns aux six dégradations présentes dans le wrapper. Cependant, 2 de ces tests sont pour l'instant en commentaire dans le code car les dégradations correspondantes contiennent de l'aléatoire (que nous n'avons pas encore rendu optionnel), rendant la comparaison des images de sortie difficile.
Pour chaque dégradation, on tente de créer plusieurs images en faisant varier les paramètres, d'abord avec les fonctions Python du wrapper, puis ensuite avec les fonctions du code C++. Si l'exécution s'est déroulée sans erreurs, on compare les images pixel par pixel, deux à deux. Si on rencontre deux images censées être identiques mais qui sont différentes, on quitte le programme et le test échoue.

## Make test
Après avoir compilé le projet, se placer dans /build puis faire
```bash
make test
```
Cette commande affichera uniquement l'échec ou le succès des tests, sans explications supplémentaire, un fichier /build/Testing/Temporary/LastTest.log sera alors généré, ce fichier contient tous les détails de l'exécution, les messages et les erreurs rencontrées. Une autre méthode pour avoir le détail de l'output durant l'exécution (y compris les commandes appelées par les tests), est de faire (toujours dans /build) :
```bash
ctest --verbose
```

## Exécution manuelle
Pour obtenir directement le détail de l'affichage des tests, il est possible de se placer dans le répertoire /build/test puis d'exécuter le script `testDegradationWrapper.py` (fichier à déplacer depuis /build/test/wrapper/python) de la manière suivante :
```bash
python testDegradationWrapper.py [degradation] [referenceImage1] [outputDirPython] [outputDirCPP] [referenceImage2] [patternImage] [patternsDir]
```
Exemple :
```bash
python testDegradationWrapper.py grayscale data/images/p00.png testDir1 testDir2 data/images/p01.png data/images/pattern1.png data/phantomCharacterPatterns/
```

Les dégradations actuellement disponibles sont :
- grayscaleChars
- shadowBinding
- holeDegradation
- bleedThrough
- phantomCharacter
- blurFilter


## Dégradations avec de l'aléatoire

Les dégradations grayscaleChars et phantomCharacter utilisent de l'aléatoire et leur tests ne seront donc exécutés que si le projet est compilé sans celui-ci, pour ce faire, depuis le dossier `build` :
```bash
cmake .. -DWITHOUT_RANDOM=ON
make
```