#include <Degradations/GrayscaleCharsDegradationModel.hpp>
#include <Degradations/ShadowBinding.hpp>
#include <Degradations/HoleDegradation.hpp>
#include <Degradations/BleedThrough.hpp>
#include <Degradations/PhantomCharacter.hpp>
#include <Degradations/BlurFilter.hpp>
//#include <opencv2/highgui/highgui.hpp>
//#include <opencv2/imgproc/imgproc.hpp>


/**
 * GrayscaleCharsDegradationModel
 */
void grayscaleChars(uint8_t *imgIn, int nbRows, int nbCols, int nbChannels,
                    uint8_t *imgOut, int imgOutLength,
                    int level = 1, float I = 33, float O = 33, float D = 34);


void grayscaleCharsByLevel(uint8_t *imgIn, int nbRows, int nbCols, int nbChannels,
                           uint8_t *imgOut, int imgOutLength,
                           int level);

/**
 * ShadowBinding
 */
void shadowBinding(uint8_t *imgIn, int nbRows, int nbCols, int nbChannels,
                   uint8_t *imgOut, int imgOutLength,
                   int border, int distance, float intensity=0.5, float angle=30);

/**
 * HoleDegradation
 */
void holeDegradation(uint8_t *imgIn, int nbRows, int nbCols, int nbChannels,
                     uint8_t *imgOut, int imgOutLength,
                     uint8_t *pattern, int nbRowsPattern, int nbColsPattern, int nbChannelsPattern,
                     int xOrigin, int yOrigin, int size, int holetype, int side, int color[3],
                     uint8_t *imgBelow=NULL, int nbRowsBelow=0, int nbColsBelow=0, int nbChannelsBelow=0,
                     int width = 0, float intensity = 1000);

/**
 * BleedThrough
 */
void bleedThrough(uint8_t *imgIn, int nbRows, int nbCols, int nbChannels,
                  uint8_t *imgOut, int imgOutLength,
                  uint8_t *imgBelow, int nbRowsBelow, int nbColsBelow, int nbChannelsBelow,
                  int nbIter, int x=0, int y=0, int nbThreads=-1);

/**
 * PhantomCharacter
 */
void phantomCharacter(uint8_t *imgIn, int nbRows, int nbCols, int nbChannels,
                      uint8_t *imgOut, int imgOutLength,
                      int frequency, char *phantomPatternsPath);

/**
 * BlurFilter
 */
void blurFilter(uint8_t *imgIn, int nbRows, int nbCols, int nbChannels,
                uint8_t *imgOut, int imgOutLength,
                int method, int intensity);
