%module Degradations


%{
    #define SWIG_FILE_WITH_INIT
    #include "Degradations.hpp"
%}

%include "numpy.i"

%init %{
    import_array();
%}


%apply (uint8_t* IN_ARRAY3, int DIM1, int DIM2, int DIM3) {(uint8_t *imgIn, int nbRows, int nbCols, int nbChannels),
                                                           (uint8_t *imgBelow, int nbRowsBelow, int nbColsBelow, int nbChannelsBelow),
                                                           (uint8_t *pattern, int nbRowsPattern, int nbColsPattern, int nbChannelsPattern)};
%apply (int IN_ARRAY1[ANY]) {(int color[ANY])};
%apply (uint8_t* ARGOUT_ARRAY1, int DIM1) {(uint8_t* imgOut, int imgOutLength)};


/* Enable kwargs everywhere, this allows us the specify the name of a
   parameter before affecting a value to it so we can pass them in any
   order (e.g.: size=10) */
%feature("kwargs") grayscaleChars;
%feature("kwargs") grayscaleCharsByLevel;
%feature("kwargs") shadowBinding;
%feature("kwargs") holeDegradation;
%feature("kwargs") bleedThrough;
%feature("kwargs") phantomCharacter;
%feature("kwargs") blurFilter;


%include "Degradations.hpp"