# Interface en ligne de commande

## Dépendance :
- Wrapper python
- Python Lex-Yacc (PLY)

    $ pip install ply

## Utilisation : CLI
Déplacez vous vers le répertoire contenant les fichiers Python que l'on a créés lors de la compilation, au choix :

    $ cd DocCreator/build/wrapper/cli
    # or
    $ cd <MyInstallationPrefix>/libpython/cli


Description de l'expression à passer en paramètre :
```
<expression> = "[(<repertoryIn>/ || <generation>(<param>)] =>[ [<function>(<param>) =>]+ <repertoryOut/>"

<function> = grayscaleChars | shadowBinding | blurFilter | holeDegradation | bleedThrough | phantomCharacter

<generation> = create
```

Les images deviennent des liens vers le répertoire contenant les images ou le lien vers une image.
Dans le cas d'un répertoire, les images qu'il contient seront utilisés à tour de rôles.

Fichier de configuration :
```
<expression>
<expression>
[...]
<expression>
```

### Description des fonction de dégradation

IMG|IMG_PATTERN = <chemin> vers un répertoire d'images ou une image
exemple : ~/data/pattern/ ou ~/data/pattern/pat01.png

COLOR = [0-255]:[0-255]:[0-255]
exemple 240:60:30

_NOM_FONCTION_    : (PARAMETRE_FONCTION)

_grayScaleChars_  : (level, `Optionnel : I`, `Optionnel : O`, `Optiennel : D`) avec I+O+D = 100
_shadowBinding_   : (border, distance, `Optionnel : intensity`, `Optionnel : angle`)
_blurFilter_      : (method, intensity)
_bleedThrough_    : (IMG, nbIter, `Optionnel : x`, `Optionnel : y`)
_phantomCharacter_: (frequency, IMG_PATTERN)
_holeDegradation_ : (IMG_PATTERN, xOrigin, yOrigin, size, holetype, side, COLOR)
                ou (IMG_PATTERN, xOrigin, yOrigin, size, holetype, side, COLOR, IMG, width, intensity)



backgroundList = image1.png:image2.png:[...]:imageN.png (image contenue dans data)
fontList = font1:font2:[...]:fontN (font contenue dans data)
txtDirPath = <chemin> vers un répertoire contenant des fichier texte
            ou LoremIpsum pour utilisé un texte ramdom
functionID = [0-4] (default 0, 1=AllFontsOneBackground, 2=OneFontAllBackgrounds, 3=FontsAllBackgrouds)

_create_          : (backgroundList, fontList, txtDirPath, `Optionnel : functionID`)

Exemple expression :
```
"r:data/imagesIn/=>grayscaleChars(50)=>phantomCharacter(2,data/phantomCharacterPatterns/)=>r:path/imageOut/"
```

Exemple fichier de configuration :
```
create(bg-1.png:montaigne-03.png,JulesVerne:manto,data/testText,2)=>r:testGeneration
r:data/imagesIn/=>grayscaleChars(50)=>r:testGrayscaleChars/
r:data/imagesIn/=>shadowBinding(3,500)=>r:testShadowBinding/
r:data/imagesIn/=>phantomCharacter(2,data/phantomCharacterPatterns/)=>r:testPhantomCharacter/
r:data/imagesIn/=>blurFilter(0,11)=>r:testBlurFilter/
r:data/imagesIn/=>bleedThrough(data/images/p01.png,50)=>r:testBleedThrough
```
Le fichier de configuration s'appelle de la manière suivante :
```bash
$ python cli.py [fichier]
```
