# DocCreatorPackage

Ce dossier contient tous les fichiers nécessaires à la génération du package _pip_ de la version Python de DocCreator.

Dans la version actuelle, notre DocCreatorPackage permet d'utiliser le wrapper Python de _Degradations_ et _Generation_ (fichiers **_Degradations.so**, **Degradations.py**, **_Generation.so** et **Generation.py**).
Il permet également d'utiliser la Cli. (Dossier **cli**, fichiers **cli.py**, **lexYaccAnalyse.py** et **ListeDegradation.py**).


## Installation du paquet :

La commande permettant d'installer le package python est :

```bash
python -m pip install --index-url https://test.pypi.org/simple/ DocCreatorPackage
```

La bibliothèque peut être utilisée dans un fichier Python avec :
```python
import DocCreator
```
L'interface en ligne de commande peut être utilisée avec :
```bash
python -m DocCreator.cli [arguments]
```


## Utilisation :

Pour l'utilisation de la Génération et des Dégradations, se référer au README présent dans DocCreator/wrapper/python


## Mettre à jour les fichiers du paquet :

Vérifier que _setuptools wheel_ et _twine_ sont bien installés :
```
python -m pip install --user --upgrade setuptools wheel twine
```

Après avoir modifié les fichiers à mettre à jour, il est nécessaire d'incrémenter le numéro de version de **setup.py**.
Il faut ensuite regénérer le contenu du dossier **/dist** :
```
rm -r dist
python setup.py sdist bdist_wheel
```

Enfin pour uploader le nouveau paquet :
```
python -m twine upload --repository-url https://test.pypi.org/legacy/ dist/*
```

Des identifiants de connexion seront alors demandés, de manière temporaire, ceux-ci ont été définis par :
    - Login :        pdp-bfhl
    - Mot de passe : Lbgfahql


## Ajouter de nouveaux fichiers :

Pour ajouter de nouveaux fichiers au package, deux procédures :

- S'il s'agit d'un fichier Python .py :
  Il suffit de l'ajouter dans le dossier /DocCreatorPackage/DocCreator avec les autres

- S'il s'agit d'un .so :
  Il est nécessaire de l'ajouter dans la ligne __package_data__ de **setup.py**, puis de l'ajouter également dans le dossier /DocCreatorPackage/DocCreator

Ensuite il faut mettre à jour le paquet suivant la procédure de mise à jour des fichiers décrite précédemment.


## Note :

Nous avons laissé les fichiers compilés du package volontairement, comme preuve de concept pour la réalisation du package pip.


