#!/bin/bash

### USAGE ###
# ./compile-project.sh <MyInstallationPrefix>

if [ $# -eq 0 ]
  then
    echo "Cannot install if you don't specify an install folder"
    exit 1
fi

# Install dir is used from /DocCreator/build, so to avoid any confusion we
# add ../../ before the specified install_dir if it doesn't start with / or ~
if ! [[ $1 == /* || $1 == ~* ]]
  then
    install_dir="../../"
fi
install_dir+=$1

cd DocCreator
mkdir build
cd build
cmake .. -DCMAKE_INSTALL_PREFIX=$install_dir
make
make install