#!/bin/bash

### USAGE ###
# sudo ./install-dependencies.sh

apt update

# DocCreator dependencies
apt install -y libopencv-dev qtbase5-dev qtdeclarative5-dev libqt5xmlpatterns5-dev cmake
apt install -y qt5-default
apt install -y tesseract-ocr tesseract-ocr-fra libtesseract-dev libleptonica-dev # Optionnal, but compilation will be slower without it

# Install Python, Python dev and SWIG
apt install -y python
apt install -y python2.7-dev
apt install -y swig

# Install numpy
apt install -y python-pip
python -m pip install numpy

# CLI : Install ply
python -m pip install ply

# Update CMake through pip (if necessary)
cmake_version="$(cmake -version)"
cut="$(cut -d'C' -f1 <<<"$cmake_version")"
version_only="$(cut -d' ' -f3 <<<"$cut")"
requiredver="3.8.2"
if ! [ "$(printf '%s\n' "$requiredver" "$version_only" | sort -V | head -n1)" = "$requiredver" ]; then
    python -m pip install --upgrade cmake
fi

# Install cv2 to load images in our Python tests
python -m pip install opencv-python
